#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri May  4 10:56:59 2018

@author: Axelsen
"""

import AIS_Analysis as AIS
import datetime

#Database = '/Users/Axelsen/Desktop/spot_fleet.db'
Database = '/Users/Axelsen/Desktop/LNG_fleet01.db'
#Database = '/Users/Axelsen/Desktop/LNG_fleet05.db'
#Database = '/Volumes/LaCie/NTNUfilesMac/SAISGlobalFinal.db'

#All methods are run from this script, 1 = run
Analysis = 1 #1 = extract data of intrest from database
LocalMap =0 # Plot all data on map 
DataClusterPorts = 0 # Cluster ports
PortAnalysis = 0 # Compare with LINNERLIB
GeoFencePorts = 0 # Geofence ports
Network = 0 # Network of port-to-port
WorldOceanAnalysis = 1 # Polygon
SpeedForAnalysis = 0 # Message interval
DraughtAnalysis = 0 #Draught analysis
DraughtHistogram = 0 # Draught histogram
SpeedHistogram = 0 #Speed histogram

Pacific = [-120,63,12,28]
Atlanter = [0,53,-80,33]
MexAu = [180,7.75,-180,-26.10]
Global = [180,90,-180,-90]
asEur = [120, 50, -15, 0]
CapeAfrica = [60,24,-30,-42]
Panama = [-79,9.8,-81,8.5]
Suez = [40,40,30,27]
Norway = [30,80,0,55]

#east, north, west, south

#Choose location of intrest:
Loc = 4

if Loc == 1:
    Pos = Pacific
elif Loc == 2:
    Pos = Atlanter
elif Loc == 3:
    Pos = MexAu
elif Loc == 4:
    Pos = Global
elif Loc == 5:
    Pos = asEur
elif Loc == 6:
    Pos = CapeAfrica
elif Loc == 7:
    Pos = Panama
elif Loc == 8:
    Pos = Suez    
elif Loc == 9:
    Pos = Norway    

#Time window of intrest:
lowtime = '01/01/2015'
hightime = '01/01/2016'

#unixtimelow = 1291236214 = 1 des 2010
# 01/01/2010
#unixtimehigh = 1443651368 = 1 jan 2016
# 01/01/2016

#Speed of interst:
maxspeed = 25
minspeed = 0

#Convert from date to unixtime:
unixlow = datetime.datetime.strptime(lowtime, "%d/%m/%Y").timestamp()
unixhigh = datetime.datetime.strptime(hightime, "%d/%m/%Y").timestamp()
    
#PV calls PlotVessels.py, which essentially does all data extracting, initial analyses,
#and visualizations of AIS data.  
if Analysis == 1:
    plotlon,plotlat = AIS.ExtractData(Database,Pos[0],Pos[1],Pos[2],Pos[3],
                   unixlow,unixhigh,maxspeed,minspeed,Analysis)

if DataClusterPorts == 1:
   clusterlat,clusterlon,labels = AIS.ClusterPorts() 
   
if SpeedForAnalysis == 1:
    AIS.SpeedForAnalysis() 
    
if DraughtAnalysis == 1:
    AIS.DraughtAnalysis()
    
if PortAnalysis == 1:
    portdata = AIS.Checkports(ports)
    
if WorldOceanAnalysis == 1:
    BigD = AIS.PolygonAnalysis(unixlow,unixhigh)
    
if GeoFencePorts == 1:
    labels = AIS.GeoFencePorts()
    
if Network == 1:
    route,G = AIS.ShippingNetwork(labels)
    
if LocalMap == 1:    
    AIS.LocalMap()

if SpeedHistogram == 1:
    AIS.SpeedHistogram()    

if DraughtHistogram == 1:
    AIS.DraughtHistogram()